=== examples/Makefile ===
# (c) Ricardas Cepas <rch@pub.osf.lt>. Copying policy: BSD or GNU GPL V2.
FONTS512 = LatArCyrHeb.uni

all:
	PWD="`pwd -P`" && cd ../../linux-lt-current/ \
		&& cp --verb --force --update \
			LatArCyrHeb.uni linux+utf8.ti \
			set_sticky_palette_for_linux-gr+utf8_terminal "$$PWD" \
		&& cp --verb --force --update \
			BSD_style_license "$$PWD"/..
	gzip --best --force LatArCyrHeb.uni 

install:
#	-kbd_share_dir=/usr/share; \
#	   install --owner=root --group=staff --mode=ug=rw,o=r \
#		$(filter %.psf, $(FONTS) $(FONTS2) $(FONTS512)) \
#				 $$kbd_share_dir/consolefonts/
#	install --owner=root --group=staff --mode=ug=rw,o=r \
#		$(filter-out %.psf, $(FONTS) $(FONTS2) $(FONTS512)) \
#				 $$kbd_share_dir/consoletrans/
	
	@echo Installing terminfo entries...
	tic linux+utf8.ti
	install --owner=root --group=root --mode=u=rwx,go=rx \
		set_sticky_palette_for_linux-gr+utf8_terminal* /usr/sbin/

.PHONY: all install
# vi: set noexpandtab:
