=== debian/control ===
Source: 2utf
Section: text
Priority: optional
Maintainer: Ricardas Cepas <rch@debian.org>
Standards-Version: 2.3.0.1

Package: 2utf
Architecture: any
Depends: ${shlibs:Depends}
Recommends: locales | wg15-locale, man-db (>= 2.3.10-37)
Suggests: tcs, kbd (>= 0.95)
Description: Translates char-sets and decodes MIME.
 Filter for char-set translation to and from Unicode.
 Gets char-set definitions from WG15 locales char-maps or similiar tables.
 Can decode nested multi-part MIME messages and invoke external filters.
 Can display char-maps and current console font.
