=== debian/rules ===
#!/usr/bin/make -f
# Sample debian.rules file - for GNU Hello (1.3).
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified

# There used to be `source' and `diff' targets in this file, and many
# packages also had `changes' and `dist' targets.  These functions
# have been taken over by dpkg-source, dpkg-genchanges and
# dpkg-buildpackage in a package-independent way, and so these targets
# are obsolete.

Package=2UTF
package=2utf

SHELL = /bin/sh

DEBDIST	= ../$(package)_$(VERSION)_$(ARCHITECTURE).changes \
	../$(package)_$(VERSION)_$(ARCHITECTURE).deb \
	../$(package)_$(VERSION).dsc \
	../$(package)_$(VERSION).tar.gz
DEBIAN	= debian/changelog debian/control.in debian/copyright debian/rules 

build:	checkdir
	$(MAKE) config
	$(MAKE) USE_LIBC=yes GZIPDOCS=yes prefix=/usr sysconfdir=/etc \
					var_prefix=/var

clean:
	$(MAKE) distclean
	$(MAKE) config
	$(MAKE) lsm
	debian/rules debian/control

binary-indep:	checkroot build
# There are no architecture-independent files to be uploaded
# generated by this package.  If there were any they would be
# made here.

binary-arch:	checkroot debian/control build $(DEBIAN)
	-rm -f -R debian/tmp
	install --directory debian/tmp/DEBIAN # debian/tmp/usr/lib/menu
	$(MAKE) GZIPDOCS=yes prefix=debian/tmp/usr sysconfdir=debian/tmp/etc \
		var_prefix=debian/tmp/var \
		docsdir=debian/tmp/usr/doc/$(package) \
		tmpdir_install=yes install
	cd debian && install --owner=root --group=root --mode=u=rwx,go=rx \
			 conffiles postinst postrm tmp/DEBIAN/
#	install --owner=root --group=root --mode=u=rw,go=r \
#			 menu debian/tmp/usr/lib/menu/$(package)
	dpkg-shlibdeps 2UTF -O >debian/substvars
	chown root.root debian/substvars
	dpkg-gencontrol
	chown -R root.root	debian/tmp
#	chown -R root.staff	debian/tmp/usr/local
	chmod -R g-ws		debian/tmp
#	chmod -R g+ws		debian/tmp/usr/local
	dpkg --build debian/tmp ..

# Below here is fairly generic really

binary:		binary-indep binary-arch

checkroot:	checkdir
	test root = "`whoami`"

checkdir:	debian/rules
#	[ $(basename $(VERSION)) -le 3 \
#		-a  $(subst .,,$(suffix $(VERSION))) -le 99 \
#		-a  -f 2UTF.c -a -f debian/rules ]

debian/control:	debian/control.in $(Package).lsm.in
	cp -f $< $@
	sed -n -e '/^Description:/,/^[^[:space:]]/p' \
		$(Package).lsm.in |sed -e '$$d' >>$@

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

.PHONY: all binary binary-arch binary-indep check checkdir checkroot \
	clean diff dist distclean disttest install realclean source tags tar \
	test uninstall upload
	

# vi: set noexpandtab:
