## 2utf 1.10

=== Makefile ===
--- 
+++ 
@@ -3,6 +3,7 @@
 #  make config
 #  make
 #  make install
+# (c) Ricardas Cepas <rch@pub.osf.lt>. Copying policy: Berkeley style
 
 Package=2UTF
 package=2utf
@@ -18,9 +19,16 @@
 
 # install files with this ownership:
 owner=root
-group=staff
+# Group is defined by `make config' (staff wheel bin root).
+# You can override it at command line:
+#   make ... group=staff
 
 install_own = -o $(owner) -g $(group)
+INSTALL_DATA = install -c	$(install_own) -m 664
+INSTALL_MAN = $(INSTALL_DATA)
+INSTALL_PROGRAM = install -c -s $(install_own) -m 775
+INSTALL_SCRIPT =  install -c $(install_own) -m 775
+MKDIR = install -d $(install_own) -m 2775
 
 include Makefile.config
 #.include "Makefile.config"
@@ -43,16 +51,17 @@
 MAN1alias = $(BINalias).1
 MAN1alias2 = toUTF.1
 SRCS    = $(BIN).c $(BIN).h utf.c hdr.h plan9.h mimedecode.c
-OBJS   = utf.o mimedecode.o
-prefix  = /usr/local
-var_prefix  = /var/local
+OBJS   = $(BIN).o mimedecode.o
+PREFIX  = /usr/local
+prefix  = ${PREFIX}
+var_prefix  = /var
 # remove trailing /
 #prefix := $(prefix:/=)
 exec_prefix = $(prefix)
 localstatedir = $(var_prefix)/lib
 ALIASES = $(localstatedir)/$(BIN).aliases
 bindir  = $(exec_prefix)/bin
-docsdir  = $(prefix)/doc/$(Package)
+docsdir  = $(prefix)/share/doc/$(Package)
 examplesdir = $(docsdir)/examples
 charmaps_localdatadir  = /usr/local/share/i18n/charmaps
 man1dir  = $(prefix)/man/man1
@@ -85,24 +94,36 @@
 		  && [ $${z%%*libc.so.[6789]*}x = x ]; } \
 		   then \
 			echo USE_LIBC_DEF = \'-DUSE_LIBC=yes\'; \
-			echo '$$(BIN): mimedecode.o' >Makefile.2; \
+			echo OptionalObjectFiles = ; \
 		   else \
 			echo \# USE_LIBC_DEF = \'-DUSE_LIBC=yes\'; \
-			echo '$$(BIN): utf.o mimedecode.o' >>Makefile.2; \
-			echo utf.o: hdr.h plan9.h >>Makefile.2; \
+			echo OptionalObjectFiles = utf.o; \
 		fi >>Makefile.config
+	set -xe; \
+		for group in staff wheel bin root; \
+		do if install -d -g $$group ./tstdir; \
+		   then \
+			echo group=$$group >>Makefile.config; \
+			rmdir ./tstdir; \
+			break; \
+		   fi; \
+		done;
 	echo VERSION = `{ pwd -P || pwd; } | \
-		sed -e 's!.*/\($(Package)\|$(package)\)-!!'` >>Makefile.config
+		sed -e 's!.*/$(Package)-!!;s!.*$(package)-!!'` >>Makefile.config
 	ARCHITECTURE="`if test -x /usr/bin/dpkg; \
 		then dpkg --print-architecture; else uname -m; fi`" \
 	&& if [ "$${ARCHITECTURE%%i?86}"y = y ]; then ARCHITECTURE=i386; fi \
 	&& echo ARCHITECTURE = "$$ARCHITECTURE" >>Makefile.config 
 
+FreeBSD_port/$(Package)/Makefile:	FreeBSD_port/$(Package)/Makefile.in
+	[ $(VERSION)x != x ]
+	sed -e 's/$${version}/$(VERSION)/g'  $? >FreeBSD_port/$(Package)/Makefile
+
 $(Package)-$(VERSION).lsm lsm:	$(Package).lsm.in
 	-rm -f $(package)*.lsm $(Package)*.lsm
 	[ $(VERSION)x != x ]
 	sed -e 's/$${date}/'`LC_ALL=C date +%d%b%y |tr a-z A-Z`'/g; \
-		s/$${version}/$(VERSION)/g'  $< >$(Package)-$(VERSION).lsm
+		s/$${version}/$(VERSION)/g'  $? >$(Package)-$(VERSION).lsm
 	touch lsm
 
 $(Package)-$(VERSION).spec:	$(Package).spec.in
@@ -114,7 +135,7 @@
 						$(Package).lsm.in`" \
 	&& sed -e 's/$${version}/$(VERSION)/g; s/$${summary}/'"$${Summary}"'/g; \
 		 s/$${copying}/'"$${Copying}"/g \
-		 $< >tmp
+		 $? >tmp
 	sed -n -e '1,/^%description/p' tmp >$@
 	sed -n -e '/^Description:/,/^[^[:space:]]/!d; /^[[:space:]]/p' \
 		$(Package).lsm.in >>$@
@@ -123,8 +144,8 @@
 
 $(BIN).o: $(BIN).h approx.c
 
-include Makefile.2
-#.include Makefile.2
+$(BIN): $(OBJS) $(OptionalObjectFiles)
+	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $(OBJS) $(OptionalObjectFiles) -o $@
 
 approx.c: approx.c.in0 approx.c.in1 approx.c.in2 approx.c.in3
 	echo -n 'char approx2ascii[][5] = { ' >$@
@@ -132,11 +153,13 @@
 	echo '};' >>$@
 
 clean:
-	-rm  -R -f *.o *~ *.bak 1 2 t t2 tt tags tmp \#*\# errors* \
+	-rm  -R -f *.o *~ *.bak 1 2 t t2 tt tags tmp tst* \#*\# errors* \
 		core* linux+utf8.ti \
 		a.out approx.c ./stdin ./stdout typescript filelist \
 		debian/control debian/tmp debian/files* debian/substvars* \
-		$(BIN) $(Package)-*.spec $(Package)-*.lsm lsm
+		$(BIN) $(Package)-*.spec $(Package)-*.lsm lsm \
+		FreeBSD_port/$(Package)/work \
+		FreeBSD_port/$(Package)/Makefile
 
 debdist $(DEBDIST):	examples $(DEBIAN) $(DOCS) $(MAN1) $(SRCS)
 	[ $(VERSION)x != x ]
@@ -144,7 +167,7 @@
 	dpkg-buildpackage
 	$(MAKE) config
 
-dist tar: $(DEBIAN) distclean examples $(DOCS) $(MAN1) $(SRCS) $(Package)-$(VERSION).lsm $(Package)-$(VERSION).spec
+dist tar: $(DEBIAN) distclean examples $(DOCS) $(MAN1) $(SRCS) $(Package)-$(VERSION).lsm $(Package)-$(VERSION).spec FreeBSD_port/$(Package)/Makefile
 	[ $(VERSION)x != x ]
 	-rm -f -R /tmp/$(Package)-$(VERSION)/
 	mkdir /tmp/$(Package)-$(VERSION)
@@ -156,15 +179,16 @@
 	$(MAKE) config
 
 distclean: clean
-	-rm -f ../$(package)_$(VERSION)_$(ARCHITECTURE).deb
+	#! -rm -f ../$(package)_$(VERSION)_$(ARCHITECTURE).deb
 	echo make_from_scratch: distclean config myself >Makefile.config 
-	echo >Makefile.2
 
 disttest:	$(DEBDIST)
+	rm -R -f /tmp/$(package)-$(VERSION)
 	cp $(addprefix ../$(package)_$(VERSION).,dsc tar.gz) /tmp/
 	cd /tmp && tar -xvzf $(package)_$(VERSION).tar.gz
-	cd /tmp/$(package)-$(VERSION) && make \
-		&& make install test uninstall
+	make rpm
+	rpm --install --force --nodeps /usr/src/redhat/RPMS/$(ARCHITECTURE)/$(Package)-$(VERSION)-0.$(ARCHITECTURE).rpm
+	rpm -qisv $(Package)
 	rm -R -f /tmp/$(package)-$(VERSION)
 	cd /tmp && dpkg-source -x $(package)_$(VERSION).dsc
 	cd /tmp/$(package)-$(VERSION) && \
@@ -174,26 +198,33 @@
 	dpkg --install  /tmp/$(package)_$(VERSION)_$(ARCHITECTURE).deb
 	cd /tmp/$(package)-$(VERSION) && rm $(DEBDIST)
 	rm -R -f /tmp/$(package)-$(VERSION)
-
-examples:
+	dpkg --purge $(package)
+	cp $(addprefix ../$(package)_$(VERSION).,dsc tar.gz) /tmp/
+	cd /tmp && tar -xvzf $(package)_$(VERSION).tar.gz
+	cd /tmp/$(package)-$(VERSION) && pmake \
+		&& pmake install test uninstall && make install SHELL=/bin/ash
+	rm -R -f /tmp/$(package)-$(VERSION)
+	$(MAKE) tar
+
+Examples:
 	if test -d ../linux-lt-current; then cd examples && make all; fi
 
 install:	all $(DOCS) $(MAN1) $(EXAMPLES) $(term_init_script)
-	install -d $(install_own) -m 2775 $(bindir)
-	install -s $(install_own) -m 775  $(BIN)      $(bindir)
+	test -e $(bindir) || $(MKDIR) $(bindir)
+	$(INSTALL_PROGRAM)  $(BIN)      $(bindir)
 	cd $(bindir) && ln -f -s $(BIN) $(BINalias)
-	install -d $(install_own) -m 2775 $(docsdir)
-	install    $(install_own) -m 664  $(DOCS)     $(docsdir)
-	install -d $(install_own) -m 2775 $(examplesdir)
-	install    $(install_own) -m 664  $(EXAMPLES) $(examplesdir)
-	install -d $(install_own) -m 2775 $(man1dir)
-	install -d $(install_own) -m 2775	$(charmaps_localdatadir)
-	install    $(install_own) -m 664  $(MAN1)     $(man1dir)
-	install -d $(install_own) -m 2775 $(sysconfdir)
+	test -e $(docsdir) || $(MKDIR) $(docsdir)
+	$(INSTALL_MAN)  $(DOCS)     $(docsdir)
+	test -e $(examplesdir) || $(MKDIR) $(examplesdir)
+	$(INSTALL_MAN)  $(EXAMPLES) $(examplesdir)
+	test -e $(man1dir) || $(MKDIR) $(man1dir)
+	$(INSTALL_MAN)  $(MAN1)     $(man1dir)
+	test -e $(sysconfdir) || $(MKDIR) $(sysconfdir)
+	set +o errexit; \
 	cmp -s $(sysconfdir)/$(BIN).config  $(BIN).config; exit_code=$$?; \
 	if [ _$$exit_code != _0 ]; then \
 		if [ _$$exit_code = _1 ]; then suffix=.new; fi; \
-		install    $(install_own) -m 664 \
+		$(INSTALL_DATA) \
 			$(BIN).config $(sysconfdir)/$(BIN).config$$suffix; \
 	fi
 	if [ $(GZIPDOCS) = yes ]; \
@@ -206,7 +237,7 @@
 		cd $(man1dir) && ln -f -s $(MAN1) $(MAN1alias) \
 		&& ln -f -s $(MAN1) $(MAN1alias2); \
 	fi
-	install -d $(install_own) -m 2775 `dirname $(ALIASES)`
+	test -e `dirname $(ALIASES)` || $(MKDIR) `dirname $(ALIASES)`
 	# check if this is install in temporary directory:
 	set -xe; \
 	if prefix=$(prefix) && \
@@ -214,31 +245,56 @@
 	then \
 		dd bs=11000 count=1 </dev/zero >$(ALIASES); \
 		chown $(owner).$(group) $(ALIASES); chmod 664 $(ALIASES); \
-		if [ $${prefix##debian*}y != y ]; \
+		if [ $${prefix##debian*}y != y ] ; \
 		then \
+		 if ! tic -V 2>&1 |grep -q tconv; then \
 		    TERMINFO=; tic linux+utf8.ti; \
-		    install -d $(install_own) -m 2775 \
+		    test -e $(prefix)/share/terminfo/l/ || $(MKDIR) \
 			    $(prefix)/share/terminfo/l/; \
 		    cp /usr/share/terminfo/l/linux+utf8 \
 			    /usr/share/terminfo/l/linux-gr+utf8 \
+			    /usr/share/terminfo/l/linux+k \
 				    $(prefix)/share/terminfo/l/; \
+		 fi; \
 		fi; \
 	else \
-		$(bindir)/$(BIN) --create-aliases; \
-		tic linux+utf8.ti; \
+		test -e $(charmaps_localdatadir) \
+			|| $(MKDIR) $(charmaps_localdatadir); \
+		if ! tic -V 2>&1 |grep -q tconv; \
+		then tic linux+utf8.ti || echo Can\'t compile terminfo source ; \
+		fi; \
+		$(bindir)/$(BIN) --create-aliases || : ; \
 	fi; \
 	if [ $${prefix%%debian*}y != y ]; \
 	then \
-		install -d $(install_own) -m 2775 $(sbindir); \
-		install $(install_own) -m 775 $(term_init_script) $(sbindir); \
+		test -e $(sbindir) || $(MKDIR) $(sbindir); \
+		$(INSTALL_SCRIPT) $(term_init_script) $(sbindir); \
 	fi
 	# you can specify directory for tic, but that doesn't work :-(
 
 linux+utf8.ti:	examples/linux+utf8.ti
-	sed -e 's!/usr/sbin!$(sbindir)!' $< >$@
+	sed -e 's!/usr/sbin!$(sbindir)!' $? >$@
 
 myself:
 	$(MAKE) all
+
+port:
+	sed -n -e 's/^Description:[[:space:]]*//p' $(Package).lsm.in \
+		> FreeBSD_port/$(Package)/pkg/COMMENT
+	{ sed -n -e '/^Description:/,/^[^[:space:]]/!d; /^[[:space:]]/p' \
+		$(Package).lsm.in |grep -v 'console font'; echo; \
+		echo '- Ricardas Cepas <rch@WriteMe.Com>'; } \
+		> FreeBSD_port/$(Package)/pkg/DESCR
+	cd FreeBSD_port/$(Package)/ # && make makesum
+	cd /tmp/ && rm -rf $(Package)
+	cd FreeBSD_port/$(Package)/work/$(Package)-$(VERSION) \
+		&& make group=wheel prefix=/tmp/$(Package) \
+			examplesdir=/tmp/$(Package)/share/examples/$(Package) install
+	{ find /tmp/$(Package) -type f -or -type l \
+          |sed -e 's!^'/tmp/$(Package)/'!!'; \
+	  echo @dirrm share/examples/$(Package); \
+	  echo @dirrm share/doc/$(Package); \
+	} > FreeBSD_port/$(Package)/pkg/PLIST
 
 realclean: distclean
 	-rm -f $(DEBDIST)
@@ -264,8 +320,7 @@
 test check:
 	$(bindir)/$(BINalias) --help
 	$(bindir)/$(BIN) --show-charmap --verbose 88591
-	@echo -n "Press <enter> ... "
-	@read a
+	@echo -n "Press <enter> ... "; read a
 
 uninstall:
 	-rm -f $(ALIASES) $(bindir)/$(BIN) $(bindir)/$(BINalias)
@@ -280,31 +335,8 @@
 	-rmdir $(examplesdir)
 	-rmdir $(docsdir)
 
-UPHOST=sunsite.unc.edu
-upload: #dist debdist ../$(Package)-$(VERSION).tar.gz $(Package)-$(VERSION).lsm
+upload: upload_main #dist debdist ../$(Package)-$(VERSION).tar.gz $(Package)-$(VERSION).lsm
 	[ $(VERSION)x != x ]
 	[ "`rpm --checksig \
 		/usr/src/redhat/SRPMS/$(Package)-$(VERSION)-*.src.rpm \
 		/usr/src/redhat/RPMS/$(ARCHITECTURE)/$(Package)-$(VERSION)-*.$(ARCHITECTURE).rpm \
-	| grep -c 'pgp md5 OK$$'`" = 2 ]
-	set -x; xPWD=`pwd` && echo -e open -r -d 10 ftp.redhat.com\\n \
-	   cd /pub/Incoming\\n \
-	   mput /usr/src/redhat/SRPMS/$(Package)-$(VERSION)-*.src.rpm \
-	    /usr/src/redhat/RPMS/$(ARCHITECTURE)/$(Package)-$(VERSION)-*.rpm\\n \
-	   dir $(Package)-$(VERSION)-0.src.rpm $(Package)-$(VERSION)-0.i386.rpm\\n \
-	   redir \>$$xPWD/../$(Package)-$(VERSION).ftp.redhat.com\\n \
-	| ncftp
-	set -x; xPWD=`pwd` && echo -e open -r -d 10 $(UPHOST)\\n \
-	   cd /incoming/Linux\\n \
-	   lcd $$xPWD\\n \
-	   mput ../$(Package)-$(VERSION).tar.gz $(Package)-$(VERSION).lsm\\n \
-	   dir $(Package)*\\n \
-	   redir $(Package)* \>../$(Package)-$(VERSION).$(UPHOST)\\n \
-	| ncftp
-	dupload --to erlangen ../$(package)_$(VERSION)_$(ARCHITECTURE).changes
-	echo -ne \\a
-	sleep 1s
-	echo -ne \\a
-
-# vi: set noexpandtab:
-
